﻿namespace Infrastructure.Attributes;

[AttributeUsage(AttributeTargets.Method, Inherited = false)]
public sealed class IdempotencyAttribute(string parameter, int seconds = 5, string message = "invalid request")
    : Attribute
{
    public string Parameter { get; } = parameter;

    public int Seconds { get; } = seconds;

    public string Message { get; } = message;
}