using Infrastructure.HttpUserContext;

namespace Infrastructure.Extensions;

public static class UserContextSetup
{
    public static IServiceCollection AddDefaultUserContext<T>(this IServiceCollection services) where T : IEquatable<T>
    {
        ArgumentNullException.ThrowIfNull(services);
        services.AddHttpContextAccessor();
        services.TryAddScoped(typeof(IUserContext<T>), typeof(UserContext<T>));
        return services;
    }
}