﻿using System.Security.Claims;

namespace Infrastructure.HttpUserContext;

public interface IUserContext<TId> where TId : IEquatable<TId>
{
    TId Id { get; }

    string Username { get; }

    string Name { get; }

    string Email { get; }

    string[] RoleIds { get; }

    string RemoteIpAddress { get; }

    JwtTokenInfo GenerateTokenInfo();

    IList<Claim> GetClaimsFromUserContext();
}