using Infrastructure.Utils;
using Microsoft.AspNetCore.Http;

namespace Infrastructure.Middlewares;

public class NotFoundMiddleware(RequestDelegate next)
{
    public async Task InvokeAsync(HttpContext context)
    {
        await next(context);

        if (context.Response.StatusCode == StatusCodes.Status404NotFound)
        {
            var path = context.Request.Path.Value;
            var message=new MessageData(false,$"request path: {path} not found",404);
            context.Response.ContentType = "application/json";
            context.Response.StatusCode = StatusCodes.Status200OK;
           await context.Response.WriteAsync(message.Serialize());
        }
    }
}