using Microsoft.IdentityModel.Tokens;

namespace Infrastructure.Security;

public class DefaultTokenHandler(IEncryptionService encryptionService, JwtSecurityTokenHandler jwtSecurityTokenHandler)
    : TokenHandler
{
    public override Task<TokenValidationResult> ValidateTokenAsync(string token,
        TokenValidationParameters validationParameters)
    {
        var decodeToken = encryptionService.Decrypt(token);
        return jwtSecurityTokenHandler.ValidateTokenAsync(decodeToken, validationParameters);
    }
}